const fork = require('child_process').fork;
var path = require('path');


function run(job_name, jobs_file_path) {
    
    var ps = fork(path.resolve(__dirname, 'spawned'));
    ps.send({job_key: job_name, path: jobs_file_path});
    ps.on('close', (code) => {
        if (code !== 0) {
            console.log(`ps process exited with code ${code}`);
        }
    });
}

function runAll(jobs_file_path) {
    
    var job_module = require(jobs_file_path);
    for(key in job_module) {
        run(key, jobs_file_path);
    }
}

exports.run = run;

exports.runAll = runAll;
